package com.logicbig.example;

import java.io.File;
import java.io.IOException;
import java.net.URL;
import java.nio.file.Files;
import java.util.ArrayList;
import java.util.List;

public class FilesInClassPathJavaExample {

    public static void main(String[] args) {
        System.out.println("-- under subfolder2 --");
        List<File> resourceFolderFiles = getResourceFolderFiles("subfolder2");
        resourceFolderFiles.stream().filter(f -> f.getName().endsWith(".txt")).forEach(System.out::println);
        System.out.println("-- under all folders in classpath --");
        resourceFolderFiles = FilesInClassPathJavaExample.getResourceFolderFiles("");
        resourceFolderFiles.stream().filter(f -> f.getName().endsWith(".txt")).forEach(System.out::println);
    }

    static List<File> getResourceFolderFiles(String folder) {
        ClassLoader loader = Thread.currentThread().getContextClassLoader();
        URL url = loader.getResource(folder);
        String path = url.getPath();
        File file = new File(path);
        List<File> files = new ArrayList<>();
        if(file.isDirectory()){
            try {
                Files.walk(file.toPath()).filter(Files::isRegularFile).forEach(f -> files.add(f.toFile()));
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
        }else{
          files.add(file);
        }
       return files;
    }
}